/* Тема, в которой обсуждается этот проект, https://clck.ru/JNqKg
   link to the topic that discusses this development: https://clck.ru/JNqKg
   v1.3.4_Dmitrysh _____14 профилей по 4 шага в каждом.
   Номер профиля отображается на дисплее в 16-ричном формате!
   v1.3.3 в редакции @SOLOway от 10-12-2020 с выбором версии ПИД для
   "тугих"/"шустрых" НИ в реализации @geleos27 и @Dmitrysh.
   Тестирование проводится на платах arduino NANO и ProMINI, на которых есть pins A6 & A7 !!!
   Задание уставки НИ от 80°C до 330°C.
   Максимальное число шагов профиля ограничено 4.
   Профили теперь сохраняются в виде структуры, по предложению Watashi.
   Добавлено обнуление integra, integra2, p1, p2, d1, d2.
   Исправлена невозможность завершения профиля при задании длительности любого шага равной 0 сек.
   Появилась возможность инициализации "тестового примерного" профиля в режиме IDLE,
   при нажатии CANCEL 5+ секунд, при этом текущий профиль перезапишется значениями из "тестового примерного".
   Появилась возможность задавать в меню минимальное и максимальное 
   значение мощности ВИ в процентах для каждого шага профиля.
   Поправлено отображение надписи "RUN!" - в статусе ПРЕДНАГРЕВ НИ не отображалась.
   Добавлена проверка на корректность ввода температуры по шагам,- последующая
   температура не должна быть меньше предыдущей.
   Во второй строке при задании мощности ВИ по шагам выводится номер шага.
   В режиме IDLE можно включать/отключать охладители платы нажатием кнопки ВПРАВО,
   теперь охладитель не стартует автоматом по окончании профиля.
   Перед компиляцией:
   а). Есть выбор варианта ПИД для НИ (для инерционных/для быстрых)-
   (по умолчанию - логика ПИД НИ - по примеру geleos27 для очень инерционных
   излучателей на НИ, обсуждение на стр.209-210. Появились дополнительные переменные 
   и коэффициенты, которые тоже нужно подбирать. Смотрите строки: 
   (byte kf2 = 60;  //Значение множителя К для Сопротивления изменению t° (f = friction))
   (static const byte buff_depth = 8; //глубина буфера 4 = 1сек., 8 = 2сек. MAX 250, увеличение кушает память).
   Логика ПИД ВИ (и для "быстрых" НИ) заменена на предложенную @Dmitrysh в посте #3009:
   "работать не по конечному значению ошибки, а по измерению температуры.").
   Если НИ на линейных галогеновых лампах - закомментировать строку #define LongBottomPid 1.
   При настройке ПИД смотрите ВНИМАТЕЛЬНО на величину делителей, 
   проставленных в функциях ПИД НИ и ВИ для составляющих P.I.D.
   б). Есть выбор между обычными одиночными (5 штук) кнопками и
   аналоговой резистивной клавиатурой с 5-ю кнопками, аналоговая - на А7.
   Если кнопки одиночные - закомментировать строку #define resist_keyboard 1
   в). Есть выбор работы с прерыванием от схемы ZCC, или с прерыванием по таймеру.
   При работе с прерыванием от схемы контроля перехода напряжения сети через ноль (ZCC),
   параметры для attachInterrupt нужно задать под свою версию схемы (FALLING или RISING)в
   конце блока void setup(), а также указать пин подключения схемы 2, или 3
   (строки #define SetInterrupt перед секцией ПИД).
   г). Появилась функция преднагрева НИ при старте пайки до 50°С с мощностью 25% по
   датчику НИ на плате,- эти значения меняются только в теле скетча перед компиляцией:
   Температуру преднагрева задаем в строке (if (tc2 >= 50) //Преднагрев до 50°С по датчику НИ),
   Мощность преднагрева задаем в строке (Output2 = 25; //Мощность НИ на этапе ПРЕДНАГРЕВ).
   В планах есть организация преднагрева для ВИ, эта версия пишется с учетом пожеланий владельцев
   керамических излучателей для НИ и для ВИ.
   д). По умолчанию на монитор компьютера/ноутбука выводятся графики температура/время
   (а в процессе настройки станции также и графики влияния состовляющих PID НИ)
   в программу SerialPortPlotter, модифицированную @geleos27:
   https://drive.google.com/drive/folders/1MJODRkzjEhu9_pDdhrgusmGDYtArU51c
   Если нравится программа irsp© от @Dmitrysh (в ней старт графиков синхронизирован со стартом пайки),
   а не SerialPortPlotter - закоментировать строку #define SerialPortPlotter 1
*/

#include <EEPROM.h>                   //библиотека энергонезависимой памяти
#include <LiquidCrystal_I2C.h>        //библиотека дисплея LCD2004 i2c
LiquidCrystal_I2C lcd(0x3f, 20, 4);   //вместо (0x3f) указываем адрес своего дисплея, например,0x27
#define resist_keyboard 1             //раскоментировать, если клавиатура резистивная
#define SerialPortPlotter 1           //раскоментировать, если ПО SerialPortPlotter
#define LongBottomPid 1               //раскоментировать, если НИ очень инерционный

//------------------------------------------------------
/*
  если детектор нуля не используется - закомментировать оба варианта
  и будет использоваться программный таймер (нужна библиотека MsTimer2.h)
  скачать по ссылке https://github.com/PaulStoffregen/MsTimer2
*/
// назначение пина детектора нуля ZCC
//#define SetInterrupt 0             //подключение к пину 2
//#define SetInterrupt 1             //подключение к пину 3

#ifndef SetInterrupt
#include <MsTimer2.h>                //библиотека таймера для работы без ZCC
#endif
//------------------------------------------------------


//---секция ПИД---//
float integra, integra2;              //интегральные составляющие ВИ и НИ
//---вводим "f2" - доп коэфициент для Pid2TEST2 НИ - это для очень инерционного НИ
float e1, p1, d1, e2, p2, d2, f2;     //ошибка регулирования, П-составляющая, Д-составляющая для ВИ и НИ соответственно
#define i_min 0.0                     //минимум И составляющей
#define i_max 100.0                   //максимум И составляющей
double  Input1;                       //текущая температура(измеренная max6675) ВИ
byte Output1;                         //выход ПИД регулятора ВИ
double  Input2;                       //текущая температура(измеренная max6675) НИ
byte Output2;                         //выход ПИД регулятора НИ

//---секция алгоритма Брезенхема---//
int er1 = 1;                      //переменная для расчета переполнения в алгоритме Брезенхема для ВИ
int er2 = 1;                      //переменная для расчета переполнения в алгоритме Брезенхема для НИ
int reg1;                         //промежуточная переменная для алгоритма Брезенхема для ВИ
int reg2;                         //промежуточная переменная для алгоритма Брезенхема для НИ
boolean out1;                     //выход импульса управления ВИ алгоритма Брезенхема
boolean out2;                     //выход импульса управления НИ алгоритма Брезенхема
#define SENSOR_SAMPLING_TIME 250  //частота обновления текущей температуры (1000=1 раз в секунду)

//---секция кнопок и пинов подключения---//
//Назначаем пины кнопок управления //аналоговая клавиатура на А7(нумерация аналоговых кнопок - от 100)
#ifdef resist_keyboard
#define PIN_RIGHT 100
#define PIN_UP 101
#define PIN_DOWN 102
#define PIN_LEFT 103
#define PIN_SELECT 104

struct A_PIN_DESC { //создаем структуру для описания ожидаемых значений на каждой аналоговой кнопке
  byte pinNo;                                    //номер пина
  int expectedValue;                             //ожидаемое значение
};
A_PIN_DESC expected_values[] = {                 //ожидаемые значения для псевдо-кнопок
  { PIN_RIGHT, 130},
  { PIN_UP, 748},
  { PIN_DOWN, 503},
  { PIN_LEFT, 323},
  { PIN_SELECT, 0}
};
#define A_PINS_COUNT sizeof(expected_values)/sizeof(A_PIN_DESC) //вычисляем сколько у нас всего аналоговых кнопок задано.
//допустимое отклонение analogRead от ожидаемого значения, при котором аналоговая кнопка считается нажатой
#define A_POSSIBLE_ABERRATION 20                 //отклонение допускаю в 20 единиц
bool digitalReadA(byte pinNo) {
  for (byte i = 0; i < A_PINS_COUNT; i++)        //ищем описание нашего всевдо-пина
  {
    A_PIN_DESC pinDesc = expected_values[i];     //берем очередное описание
    if (pinDesc.pinNo == pinNo)                  //нашли описание пина?
    {
      int value = analogRead(A7);                //читаем аналоговый вход A7, на котором клавиатура
      //возвращаем HIGH если отклонение от ожидаемого не больше чем на A_POSSIBLE_ABERRATION
      return (abs(value - pinDesc.expectedValue) < A_POSSIBLE_ABERRATION);
    }
  }
  return LOW;                                    //если не нашли описания - считаем что пин у нас LOW
}
//Назначаем пины кнопок управления
int upSwitchPin = PIN_UP;
int downSwitchPin = PIN_DOWN;
int cancelSwitchPin = PIN_LEFT;
int okSwitchPin = PIN_SELECT;
int rightSwitchPin = PIN_RIGHT;
#endif

#ifndef resist_keyboard
byte upSwitchPin = A0;                          //пин кнопки вверх
byte downSwitchPin = A1;                        //пин кнопки вниз
byte cancelSwitchPin = A2;                      //пин кнопки отмена или назад
byte okSwitchPin = A3;                          //пин кнопки ОК или подтверждения
byte rightSwitchPin = A6;                       //пин кнопки вправо
#endif

//состояние кнопок по умолчанию
boolean upSwitchState = 0;
boolean downSwitchState = 0;
boolean cancelSwitchState = 0;
boolean okSwitchState = 0;
boolean rightSwitchState = 0;
//переменные для кнопок
long ms_button = 0;
boolean  button_state = false;                  //для короткого и обычного нажатий
boolean  button_long_state = false;             //для длительного нажатия

//---управляем охладителем платы кнопкой ВПРАВО
boolean butt_flag = false;                      //последнее состояние для кнопки ВПРАВО
boolean butt;                                   //текущее состояние кнопки ВПРАВО
boolean Fan_flag = 0;                           //состояние охладителя платы

#define RelayPin1 12                            //назначаем пин "ВЕРХНЕГО" нагревателя
#define RelayPin2 11                            //назначаем пин "НИЖНЕГО" нагревателя
#define buzzerPin 10                            //назначаем пин пищалки
#define Int_Fan  4                              //назначаем пин охладителя симисторов и контроллера
#define Ext_Fan  5                              //назначаем пин охладителя платы

//назначаем пины преобразователей термопар
#define thermoSO  6                             //DO=(SO)
#define thermoCLK  7                            //SCK=(CLK)
#define thermoCStop  8                          //CS MAX6675 "ВЕРХНЕГО" нагревателя
#define thermoCSbott  9                         //CS MAX6675 "НИЖНЕГО" нагревателя

//---секция профиля---//
struct pr {                                     // основные поля профиля
  byte profileSteps;                            //количество шагов профиля
  int Setpoint2;                                //установленная температура(уставка)НИ
  byte pwr_BOTTOM;                              //максимальная мощность нижнего нагревателя
  byte min_pwr_TOPStep[4];                      //минимальная мощность верхнего нагревателя
  byte max_pwr_TOPStep[4];                      //максимальная мощность верхнего нагревателя
  byte rampRateStep[4];                         //скорости роста температуры по шагам
  byte temperatureStep[4];                      //заданные температуры для шагов профиля ВИ
  byte dwellTimerStep[4];                       //установленное время перехода на следующий шаг (полочка на шаге)
  byte kp1;                                     //пропорциональный коэффициент ПИД для ВИ
  byte ki1;                                     //интегральный коэффициент ПИД для ВИ
  byte kd1;                                     //дифференциальный коэффициент ПИД для ВИ
  byte kp2;                                     //пропорциональный коэффициент ПИД для НИ
  byte ki2;                                     //интегральный коэффициент ПИД для НИ
  byte kd2;                                     //дифференциальный коэффициент ПИД для НИ
};
byte SizeProfile = sizeof(pr);                  //длина поля данных
pr profile;
//---доп коэфициент для Pid2TEST2 НИ
byte kf2 = 60;                                  //Значение множителя К для Сопротивления изменению t° (f = friction)
byte currentProfile = 1;                        //текущий профиль
byte editStep = 0;                              //номер шага профиля который редактируется в данный момент
byte currentStep = 1;                           //текущий шаг профиля
byte Setpoint1;                                 //установленная температура(уставка) ВИ

//---Секция флагов---//
boolean TopStart = false;                       //флаг включения ВИ
boolean flag = 0;                               //флаг для фиксации стартовой температуры и начала работы нагревателей
byte x = 1;                                     //переменная для перехода на нужный шаг при горячей плате
boolean alarmOn = false;                        //признак предупреждения
boolean updateScreen = true;                    //признак обновления экрана

//---Секция переменных общего назначения---//
int startTemp;                     //стартовая температура для профиля, когда НИ вышел на уставку, используется для определения шага профиля с которого начинаем
byte setpointRamp;                 //заданная температура по определённому шагу профиля ВИ, связана с заданной скоростью роста температуры
byte curCount = 0;                 //знакоместо звездочек (они бегают по LCD в режиме RUN)
byte counter;                      //счётчик для рампы и счетчик для времени нахождения в шаге
unsigned long previousMillis;      //это для счетчиков
unsigned long nextRead2;           //переменная для обновления текущей температуры и расчёта ПИД
unsigned long nextRead1;           //переменная для движения "звёздочек" при пайке и подготовки данных для передачи на ПК
int tc1;                           //переменная для хранения текущей температуры ВИ
int tc2;                           //переменная для хранения текущей температуры НИ
int i = 0;
#define GRAPHICS_SAMPLING_TIME 500 //скорость движения "звёздочек" при пайке

//---структура статусов событий---//
// ***** TYPE DEFINITIONS *****
typedef enum REFLOW_STATE : byte
{
  REFLOW_STATE_IDLE,                      //экран в режиме простоя, выбор номера профиля
  REFLOW_STATE_MENU_STEPS,                //меню выбора числа шагов редактируемого профиля
  REFLOW_STATE_MENU_BOTTOM_HEAT,          //меню выбора уставки НИ редактируемого профиля
  REFLOW_STATE_MENU_BOTTOM_PWR,           //меню выбора мощности НИ редактируемого профиля
  REFLOW_STATE_MENU_TOP_PWR_MIN,          //меню выбора мин. мощности ВИ в шагах редактируемого профиля
  REFLOW_STATE_MENU_TOP_PWR_MAX,          //меню выбора макс. мощности ВИ в шагах редактируемого профиля
  REFLOW_STATE_MENU_STEP_RAMP,            //меню выбора скорости роста t° ВИ на конкретном шаге редактируемого профиля
  REFLOW_STATE_MENU_STEP_TARGET,          //меню выбора t° уставки ВИ на конкретном шаге редактируемого профиля
  REFLOW_STATE_MENU_STEP_DWELL,           //меню выбора времени удержания t° уставки ВИ на конкретном шаге редактируемого профиля
  REFLOW_STATE_MENU_BOTTOM_P,             //меню выбора коэффициента P для НИ редактируемого профиля
  REFLOW_STATE_MENU_BOTTOM_I,             //меню выбора коэффициента I для НИ редактируемого профиля
  REFLOW_STATE_MENU_BOTTOM_D,             //меню выбора коэффициента D для НИ редактируемого профиля
  REFLOW_STATE_MENU_TOP_P,                //меню выбора коэффициента P для ВИ редактируемого профиля
  REFLOW_STATE_MENU_TOP_I,                //меню выбора коэффициента I для ВИ редактируемого профиля
  REFLOW_STATE_MENU_TOP_D,                //меню выбора коэффициента D для ВИ редактируемого профиля
  REFLOW_STATE_PRE_HEATER,                //состояние преднагрева НИ в момент старта профиля
  REFLOW_STATE_STEP_RAMP,                 //"процесс пайки", рост температуры с заданной для текущего шага ВИ скоростью
  REFLOW_STATE_STEP,
  REFLOW_STATE_STEP_DWELL,
  REFLOW_STATE_COMPLETE,
  REFLOW_STATE_ERROR,
  REFLOW_STATE_PROFILE_INIT
}
reflowState_t;
typedef enum REFLOW_STATUS : byte         //структура статуса пайки, запущен или нет
{
  REFLOW_STATUS_OFF,
  REFLOW_STATUS_ON
}
reflowStatus_t;
reflowStatus_t reflowStatus;              //переменная статусов событий
reflowState_t reflowState;                //переменная статуса пайки
//---структура статусов событий---//

char buf[40];                              //расширенный буфер, если выводим больше данных
//char buf[32];                              //стандартный буфер, если станцию настроили

//---начальные установки---//
void setup() {  
  Serial.begin(9600);
  //устанавливаем пины кнопок на ВХОД и подключаем подтягивающие резисторы
#ifndef resist_keyboard
  pinMode (upSwitchPin, INPUT_PULLUP); //подключен подтягивающий резистор
  pinMode (downSwitchPin, INPUT_PULLUP); //подключен подтягивающий резистор
  pinMode (cancelSwitchPin, INPUT_PULLUP); //подключен подтягивающий резистор
  pinMode (okSwitchPin, INPUT_PULLUP); //подключен подтягивающий резистор
  pinMode (rightSwitchPin, INPUT_PULLUP); //подключен подтягивающий резистор
#endif
#ifdef resist_keyboard
  pinMode(A7, INPUT);
#endif

  //задаём состояние пинов, к которым подключены MAX6675
  pinMode(thermoCStop, OUTPUT);
  pinMode(thermoCSbott, OUTPUT);
  pinMode(thermoCLK, OUTPUT);
  pinMode(thermoSO, INPUT);

  //устанавливаем пин пищалки на ВЫХОД
  pinMode(buzzerPin, OUTPUT);

  //устанавливаем пины охладителей на ВЫХОД
  pinMode (Int_Fan, OUTPUT);
  pinMode (Ext_Fan, OUTPUT);

  //задаём состояние пинов управления выходами
  pinMode(RelayPin1, OUTPUT);
  pinMode(RelayPin2, OUTPUT);

  //сообщение приветствия
  lcd.begin();
  lcd.clear();
  lcd.setCursor(3, 0);
  lcd.print("ARDUINO REWORK");
  lcd.setCursor(2, 1);
  lcd.print("v1.3.4.  SPP/irsp");
  lcd.setCursor(2, 2);
  lcd.print("Dmitrysh geleos27");
  lcd.setCursor(2, 3);
  lcd.print("max6675  lcd2004");

  SongHello ();                            //Мелодия приветствия

  loadProfile();                           //вызов функции loadProfile для загрузки данных профиля из eeprom
  delay(5000);                             //показываем заставку пока стабилизируются MAX6675
  lcd.clear();

  nextRead2 = millis();                    //запускаем чтение с термопар
  //---настраиваем работу с прерыванием---//
  /* -------------------------------------------------------------------------------
    LOW вызывает прерывание, когда на порту LOW
    CHANGE прерывание вызывается при смене значения на порту, с LOW на HIGH и наоборот
    RISING прерывание вызывается только при смене значения на порту с LOW на HIGH
    FALLING прерывание вызывается только при смене значения на порту с HIGH на LOW
    ------------------------------------------------------------------------------- */
#ifdef SetInterrupt
  attachInterrupt(SetInterrupt, Dimming, RISING); // настроить порт прерывания(0 или 1) 2й или 3й цифровой пин
#else
  MsTimer2::set(10, Dimming); // 100ms period
  MsTimer2::start();
#endif
}

//---основной цикл программы---//
void loop() {
#ifdef resist_keyboard
  //Считываем состояние кнопок управления
  upSwitchState = digitalReadA(upSwitchPin);
  downSwitchState = digitalReadA(downSwitchPin);
  cancelSwitchState = digitalReadA(cancelSwitchPin);
  okSwitchState = digitalReadA(okSwitchPin);
  rightSwitchState = digitalReadA(rightSwitchPin);
//#endif
#else
//#ifndef resist_keyboard
  //Считываем состояние кнопок управления для обычных кнопок
  upSwitchState = !digitalRead(upSwitchPin);
  downSwitchState = !digitalRead(downSwitchPin);
  cancelSwitchState = !digitalRead(cancelSwitchPin);
  okSwitchState = !digitalRead(okSwitchPin);
  rightSwitchState = !digitalRead(rightSwitchPin);
#endif

  unsigned long currentMillis = millis();

  //SP2 = profile.Setpoint2;
  int SP2 = profile.Setpoint2 * 10;                  //множим уставку НИ на 10

  //ClickBeep ();                     //звук при нажатии на кнопки (нервирует), кому надо раскоментируйте

  if (reflowState == REFLOW_STATE_COMPLETE || alarmOn) {
    if (i < 2 && cancelSwitchState == LOW)
    {
      alarmOn = true;
      GongAlarm ();                                     //звук предупреждения
      i++;
    }  else {
      i = 0;
      alarmOn = false;
    }
  }

  switch (reflowState) {
    case REFLOW_STATE_IDLE:
      TopStart = false;
      currentStep = 1;
      counter = 0;
      setpointRamp = 0;
      x = 1;                                            //устанавливаем переменную в исходное состояние
      flag = 0;                                         //после отановки профиля сбрасываем флаг
      Output1 = 0;
      Output2 = 0;

      if (millis() > nextRead2) {    
        nextRead2 = millis() + SENSOR_SAMPLING_TIME;    //устраняем колебания датчиков температуры
        Input1 = Input1 * 0.8 + 0.2 * (max6675_read_temp (thermoCLK, thermoCStop, thermoSO)); //термопара "ВЕРХНЕГО" нагревателя
        Input2 = Input2 * 0.8 + 0.2 * (max6675_read_temp (thermoCLK, thermoCSbott, thermoSO)); //термопара "НИЖНЕГО"  нагревателя
        tc1 = Input1;
        tc2 = Input2;

        //готовим данные для вывода на ПК
#ifdef SerialPortPlotter
        sprintf (buf, "$%03d %03d %03d %03d;", int(Output1), int(Output2), tc1, tc2); // стандартный вывод данных
//#endif
#else
//#ifndef SerialPortPlotter
        sprintf (buf, "OK%03d%03d%03d%03d%03d\r\n", int(Output1), int(Output2), tc1, tc2, currentProfile);
#endif

        lcd.setCursor(16, 2);
        lcd.print("    ");
        lcd.setCursor(16, 2);
        if (isnan(Input1)) lcd.print("Er");
       // {
       //   lcd.print("Er");
       // }
       // else {
       //   lcd.print(tc1);
       // }
       else  lcd.print(tc1);
       
        lcd.setCursor(16, 3);
        lcd.print("    ");
        lcd.setCursor(16, 3);
        if (isnan(Input2)) lcd.print("Er");
       // {
       //   lcd.print("Er");
       // }
       // else {
       //   lcd.print(tc2);
       // }
       else  lcd.print(tc2);
      }

      //Обновляем экран один раз
      if (updateScreen)  {    
        //Настройка экрана в режиме ожидания
        lcd.clear();
        lcd.setCursor(8, 0);
        lcd.print("IDLE");
        lcd.setCursor(1, 1);
        lcd.print("PTN:");
        lcd.print("       STEP:1");
        lcd.setCursor(0, 2);
        lcd.print(" TH  SP:");
        lcd.setCursor(13, 2);
        lcd.print("PV:");
        lcd.setCursor(0, 3);
        lcd.print(" BH  SP:");
        lcd.setCursor(13, 3);
        lcd.print("PV:");
        updateScreen = false;
      }
      lcd.setCursor(5, 1);
      lcd.print(currentProfile, HEX);
      lcd.print(" ");
      lcd.setCursor(8, 2);
      lcd.print(profile.temperatureStep[0]);
      lcd.print("  ");
      lcd.setCursor(8, 3);
      lcd.print(SP2);
      lcd.print("  ");

      if (upSwitchState == HIGH && ( millis() - ms_button) > 500)  { //если нажата ВВЕРХ, то перейти к следующему профилю
            ms_button =  millis();
        currentProfile = currentProfile + 1;
        if (currentProfile >= 15) currentProfile = 1; //если текущий профиль > 14, нужно вернуться к профилю 1
        //{
        //  currentProfile = 1;
        //}
        loadProfile(); //вызов функции loadProfile для загрузки данных профиля из eeprom
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 500)  { //если нажата ВНИЗ, то перейти к предыдующему профилю    
        ms_button =  millis();
        currentProfile = currentProfile - 1;
        if (currentProfile <= 0) currentProfile = 14;
        //{
        //  currentProfile = 14;
        //}
        loadProfile(); //вызов функции loadProfile для загрузки данных профиля из eeprom
      }

      if (cancelSwitchState == HIGH && !button_long_state)  {          //засекаем время долгого нажатия на кнопку
        ms_button = millis();
        button_long_state = true;
      }
      //---СЕКЦИЯ ИНИЦИАЛИЗАЦИИ ТЕСТОВОГО ПРОФИЛЯ
      //держим "cancel" 5+ секунды и заходим в инициализацию профиля
      if (cancelSwitchState == HIGH && button_long_state && ( millis() - ms_button) > 5000) {    
        button_long_state = false;
        reflowState = REFLOW_STATE_PROFILE_INIT;
      }
      //фиксируем момент нажатия кнопки "ОК" + защита от дребезга
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200) {      
        ms_button =  millis();
        button_state = true;
        button_long_state = false;
      }

      //держим "ОК" 5+ секунд и заходим в меню настроек
      if (okSwitchState == HIGH && !button_long_state && ( millis() - ms_button) > 5000)
      {
        button_long_state = true;
        button_state = false;
        reflowState = REFLOW_STATE_MENU_STEPS;
        updateScreen = true;
      }

      //включаем пайку, кнопка сработает после отпускания "ОК" если нажатие меньше 5-и секунд
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        tone(buzzerPin, 1045, 500);                   //звуковой сигнал при старте профиля
        updateScreen = true;

#ifndef SerialPortPlotter
        sprintf (buf, "SYNC\r\n");
        Serial.print(buf);
#endif

        curCount = 0;
        nextRead1 = millis();
        nextRead2 = millis();
        digitalWrite(Ext_Fan, LOW);                  //выключить охладитель платы
        digitalWrite(Int_Fan, HIGH);                 //включить охладитель симисторов и контроллера
        integra = 0;
        integra2 = 0;
        p1 = 0;
        p2 = 0;
        d1 = 0;
        d2 = 0;
        Output2 = 25;                                //Мощность НИ на этапе ПРЕДНАГРЕВ
        reflowStatus = REFLOW_STATUS_ON;
        reflowState = REFLOW_STATE_PRE_HEATER;
        updateScreen = true;
      }
      //---управляем охладителем платы кнопкой ВПРАВО
      butt = !digitalReadA(rightSwitchPin);
      butt = !digitalRead(rightSwitchPin);
      if (butt == 0 && butt_flag == true && ( millis() - ms_button) > 200)
      {
        butt_flag = false;
        Fan_flag = !Fan_flag;
        digitalWrite(Ext_Fan, Fan_flag); //включить охладитель платы
        ms_button =  millis();
      }
      if (butt == 1 && butt_flag == false && ( millis() - ms_button) > 200)
      {
        butt_flag = true;
        ms_button =  millis();
      }
      /*if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
        {
        ms_button =  millis();
        digitalWrite(Ext_Fan, LOW); //выключить охладитель платы
        }
        if (rightSwitchState == HIGH && ( millis() - ms_button) > 50)
        {
        ms_button =  millis();
        digitalWrite(Ext_Fan, HIGH); //включить охладитель платы
        }*/
      break;

    //инициализация тестового профиля
    case REFLOW_STATE_PROFILE_INIT:
      /* 4 шага, уставка НИ 160° (записываем поделив на 10, показываем как обычно),
         BOTTOM PWR 50%,
         min TOP PWR по шагам 10%,10%,10%,10%
         max TOP PWR по шагам 100%,100%,100%,100%
         скорости роста t° по шагам 10,3,3,6
         уставки ВИ по шагам 18,190,200,225
         длительности полок по шагам 10,15,15,30
         P.I.D BOTTOM 8,20,40, P.I.D TOP 10,15,40 */

      profile = {4, 16, 50, 10, 10, 10, 10, 100, 100, 100, 100, 10, 3, 3, 6, 180, 190, 200, 225, 10, 15, 15, 30, 10, 15, 40, 8, 20, 40};
      SaveProfile();
      tone(buzzerPin, 800, 200);  //звуковой сигнал при сбросе профиля
      lcd.clear();
      lcd.setCursor(0, 1);
      lcd.print("INTERNAL PROFILE YES");
      delay(3000);
      button_long_state = false;
      updateScreen = true;
      reflowState = REFLOW_STATE_IDLE;
      break;

    //устанавливаем количество шагов профиля
    case REFLOW_STATE_MENU_STEPS:
      if (updateScreen)
      {
        lcd.clear();
        lcd.setCursor(3, 0);
        lcd.print("Profile ");
        lcd.print(currentProfile, HEX);
        lcd.print(" Edit");
        lcd.setCursor(0, 1);
        lcd.print("                    ");
        lcd.setCursor(2, 2);
        lcd.print("Profile  Steps: ");
        lcd.print(profile.profileSteps);
        updateScreen = false;
      }
      lcd.setCursor(17, 2);
      lcd.print(profile.profileSteps);
      lcd.print("  ");
      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        profile.profileSteps = profile.profileSteps + 1;
        if (profile.profileSteps >= 5)
        {
          profile.profileSteps = 1;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        profile.profileSteps = profile.profileSteps - 1;
        if (profile.profileSteps <= 0)
        {
          profile.profileSteps = 4;
        }
      }
      if (okSwitchState == LOW && button_long_state) button_long_state = false; //чтобы после входа в меню кнопка "ОК" не считалась нажатой
      if (okSwitchState == HIGH && !button_state && !button_long_state && ( millis() - ms_button) > 100)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_BOTTOM_HEAT;
        SaveProfile ();
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

    //устанавливаем температуру "Нижнего Нагревателя"
    case REFLOW_STATE_MENU_BOTTOM_HEAT:
      if (updateScreen)
      {
        lcd.setCursor(2, 2);
        lcd.print("Bottom  Heat:      ");
        updateScreen = false;
      }
      lcd.setCursor(15, 2);
      lcd.print(SP2);
      lcd.print("  ");

      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        profile.Setpoint2 = profile.Setpoint2 + 1;
        if (profile.Setpoint2 >= 35) // деленная на 10
        {
          profile.Setpoint2 = 35; // деленная на 10
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        profile.Setpoint2 = profile.Setpoint2 - 1;
        if (profile.Setpoint2 <= 8) // деленная на 10
        {
          profile.Setpoint2 = 8; // деленная на 10
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_BOTTOM_PWR;
        SaveProfile ();
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

    //устанавливаем максимальную мощность "НИЖНЕГО НАГРЕВАТЕЛЯ"
    case REFLOW_STATE_MENU_BOTTOM_PWR:
      if (updateScreen)
      {
        lcd.setCursor(2, 2);
        lcd.print("Bottom  PWR:    ");
        updateScreen = false;
      }
      lcd.setCursor(14, 2);
      lcd.print(profile.pwr_BOTTOM);
      lcd.print("%  ");

      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        profile.pwr_BOTTOM = profile.pwr_BOTTOM + 1;
        if (profile.pwr_BOTTOM >= 100)
        {
          profile.pwr_BOTTOM = 100;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        if (profile.pwr_BOTTOM < 1)
        {
          profile.pwr_BOTTOM = 0;
        }  else profile.pwr_BOTTOM = profile.pwr_BOTTOM - 1;
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_TOP_PWR_MIN;
        SaveProfile ();
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

    //устанавливаем минимальную мощность "ВЕРХНЕГО НАГРЕВАТЕЛЯ"
    case REFLOW_STATE_MENU_TOP_PWR_MIN:
      if (updateScreen)
      {
        lcd.setCursor(2, 2);
        lcd.print("Top  minPWR:   ");
        lcd.setCursor(7, 1);
        lcd.print("Step ");
        lcd.print(editStep + 1);
        updateScreen = false;
      }
      lcd.setCursor(14, 2);
      lcd.print(profile.min_pwr_TOPStep[editStep]);
      lcd.print("%  ");

      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        profile.min_pwr_TOPStep[editStep] = profile.min_pwr_TOPStep[editStep] + 1;
        if (profile.min_pwr_TOPStep[editStep] >= 100)
        {
          profile.min_pwr_TOPStep[editStep] = 100;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        if (profile.min_pwr_TOPStep[editStep] < 1)
        {
          profile.min_pwr_TOPStep[editStep] = 0;
        }
        else profile.min_pwr_TOPStep[editStep] = profile.min_pwr_TOPStep[editStep] - 1;
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        if (editStep + 1 == profile.profileSteps)
        {
          editStep = 0;
          SaveProfile ();
          reflowState = REFLOW_STATE_MENU_TOP_PWR_MAX;
        }
        else editStep++;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

    //устанавливаем максимальную мощность "ВЕРХНЕГО НАГРЕВАТЕЛЯ"
    case REFLOW_STATE_MENU_TOP_PWR_MAX:
      if (updateScreen)
      {
        lcd.setCursor(2, 2);
        lcd.print("Top  maxPWR:   ");
        lcd.setCursor(7, 1);
        lcd.print("Step ");
        lcd.print(editStep + 1);
        updateScreen = false;
      }
      lcd.setCursor(14, 2);
      lcd.print(profile.max_pwr_TOPStep[editStep]);
      lcd.print("%  ");

      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        profile.max_pwr_TOPStep[editStep] = profile.max_pwr_TOPStep[editStep] + 1;
        if (profile.max_pwr_TOPStep[editStep] >= 100)
        {
          profile.max_pwr_TOPStep[editStep] = 100;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        if (profile.max_pwr_TOPStep[editStep] < 1)
        {
          profile.max_pwr_TOPStep[editStep] = 0;
        }
        else profile.max_pwr_TOPStep[editStep] = profile.max_pwr_TOPStep[editStep] - 1;
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        if (editStep + 1 == profile.profileSteps)
        {
          editStep = 0;
          SaveProfile ();
          reflowState = REFLOW_STATE_MENU_STEP_RAMP;
          lcd.setCursor(7, 1);
          lcd.print("      ");
        }
        else editStep++;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

    //устанавливаем скорость нагрева "Верхним Нагревателем"
    case REFLOW_STATE_MENU_STEP_RAMP:
      if (updateScreen)
      {
        lcd.setCursor(2, 2);
        lcd.print("Step ");
        lcd.print(editStep + 1);
        lcd.print("  Ramp:     ");
        updateScreen = false;
      }
      lcd.setCursor(15, 2);
      lcd.print(profile.rampRateStep[editStep]);
      lcd.print(" ");
      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        profile.rampRateStep[editStep] = profile.rampRateStep[editStep] + 1;
        if (profile.rampRateStep[editStep] >= 30)  //максимальная скорость роста температуры умноженная на 10
        {
          profile.rampRateStep[editStep] = 30;  //максимальная скорость роста температуры умноженная на 10
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        profile.rampRateStep[editStep] = profile.rampRateStep[editStep] - 1;
        if (profile.rampRateStep[editStep] <= 1)  // минимальная скорость роста температуры умноженная на 10
        {
          profile.rampRateStep[editStep] = 1;  // минимальная скорость роста температуры умноженная на 10
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        if (editStep + 1 == profile.profileSteps)
        {
          editStep = 0;
          SaveProfile ();
          reflowState = REFLOW_STATE_MENU_STEP_TARGET;
        }
        else editStep++;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        updateScreen = true;
        editStep = 0;
        lcd.clear();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

    //устанавливаем температуру "Верхнего Нагревателя"
    case REFLOW_STATE_MENU_STEP_TARGET:
      if (updateScreen)
      {
        lcd.setCursor(1, 2);
        lcd.print("Step ");
        lcd.print(editStep + 1);
        lcd.print("  Target: ");
        lcd.print(profile.temperatureStep[editStep]);
        lcd.print("  ");
        updateScreen = false;
      }
      lcd.setCursor(16, 2);
      lcd.print(profile.temperatureStep[editStep]);
      lcd.print("  ");
      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        profile.temperatureStep[editStep] = profile.temperatureStep[editStep] + 1;
        if (profile.temperatureStep[editStep] >= 255)
        {
          profile.temperatureStep[editStep] = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        profile.temperatureStep[editStep] = profile.temperatureStep[editStep] - 1;
        if (profile.temperatureStep[editStep] <= 0)
        {
          profile.temperatureStep[editStep] = 0;
        }
        if (editStep > 0 && profile.temperatureStep[editStep] < profile.temperatureStep[editStep - 1])
          profile.temperatureStep[editStep] = profile.temperatureStep[editStep - 1];
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        if (editStep + 1 == profile.profileSteps)
        {
          editStep = 0;
          SaveProfile ();
          reflowState = REFLOW_STATE_MENU_STEP_DWELL;
        }
        else {
          editStep++;
          if (profile.temperatureStep[editStep] < profile.temperatureStep[editStep - 1])
            profile.temperatureStep[editStep] = profile.temperatureStep[editStep - 1];
        }
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        updateScreen = true;
        editStep = 0;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

    //устанавливаем время перехода на следующий шаг (длительность шага)
    case REFLOW_STATE_MENU_STEP_DWELL:
      if (updateScreen)
      {
        lcd.setCursor(1, 2);
        lcd.print("Step ");
        lcd.print(editStep + 1);
        lcd.print("   Dwell:");
        lcd.print(profile.dwellTimerStep[editStep]);
        lcd.print("  ");
        updateScreen = false;
      }
      lcd.print("  ");
      lcd.setCursor(16, 2);
      lcd.print(profile.dwellTimerStep[editStep]);
      lcd.print("  ");
      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        profile.dwellTimerStep[editStep] = profile.dwellTimerStep[editStep] + 5;
        if (profile.dwellTimerStep[editStep] >= 180)
        {
          profile.dwellTimerStep[editStep] = 180;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();

        if (profile.dwellTimerStep[editStep] < 5)
        {
          profile.dwellTimerStep[editStep] = 0;
        }
        else profile.dwellTimerStep[editStep] = profile.dwellTimerStep[editStep] - 5;
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        if (editStep + 1 == profile.profileSteps)
        {
          editStep = 0;
          SaveProfile ();
          reflowState = REFLOW_STATE_MENU_BOTTOM_P;
        }
        else editStep++;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        updateScreen = true;
        editStep = 0;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

    //настройка "ПИД" нижнего нагревателя
    case REFLOW_STATE_MENU_BOTTOM_P:
      if (updateScreen)
      {
        lcd.setCursor(0, 2);
        lcd.print("                  ");
        lcd.setCursor(3, 2);
        lcd.print("Bottom Heater:  ");
        lcd.setCursor(8, 3);
        lcd.print("P=");
        lcd.print(profile.kp2);
        lcd.print("  ");
        updateScreen = false;
      }
      lcd.setCursor(10, 3);
      lcd.print(profile.kp2);
      lcd.print("  ");
      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        if (profile.kp2 >= 255)
        {
          profile.kp2 = 255;
        }
        else profile.kp2 = profile.kp2 + 1;
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        if (profile.kp2 < 1)
        {
          profile.kp2 = 0;
        }
        else profile.kp2 = profile.kp2 - 1;
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_BOTTOM_I;
        SaveProfile ();
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
    case REFLOW_STATE_MENU_BOTTOM_I:
      lcd.setCursor(8, 3);
      lcd.print("I=");
      lcd.print(profile.ki2);
      lcd.print("  ");
      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        if (profile.ki2 >= 255)
        {
          profile.ki2 = 255;
        }
        else profile.ki2 = profile.ki2 + 1;
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        if (profile.ki2 < 1)
        {
          profile.ki2 = 0;
        }
        else profile.ki2 = profile.ki2 - 1;
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        reflowState = REFLOW_STATE_MENU_BOTTOM_D;
        SaveProfile ();
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
    case REFLOW_STATE_MENU_BOTTOM_D:
      lcd.setCursor(8, 3);
      lcd.print("D=");
      lcd.print(profile.kd2);
      lcd.print("  ");
      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        if (profile.kd2 >= 255)
        {
          profile.kd2 = 255;
        }
        else profile.kd2 = profile.kd2 + 1;
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        if (profile.kd2 < 1)
        {
          profile.kd2 = 0;
        }
        else profile.kd2 = profile.kd2 - 1;
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        reflowState = REFLOW_STATE_MENU_TOP_P;
        SaveProfile ();
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

    //настройка "ПИД" верхнего нагревателя
    case REFLOW_STATE_MENU_TOP_P:
      if (updateScreen)
      {
        lcd.setCursor(0, 2);
        lcd.print("                  ");
        lcd.setCursor(5, 2);
        lcd.print("Top Heater:");
        lcd.setCursor(8, 3);
        lcd.print("P=");
        lcd.print(profile.kp1);
        lcd.print("  ");
        updateScreen = false;
      }
      lcd.setCursor(10, 3);
      lcd.print(profile.kp1);
      lcd.print("  ");
      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        if (profile.kp1 >= 255)
        {
          profile.kp1 = 255;
        }
        else profile.kp1 = profile.kp1 + 1;
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        if (profile.kp1 < 1)
        {
          profile.kp1 = 0;
        }
        else profile.kp1 = profile.kp1 - 1;
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_TOP_I;
        SaveProfile ();
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
    case REFLOW_STATE_MENU_TOP_I:
      lcd.setCursor(8, 3);
      lcd.print("I=");
      lcd.print(profile.ki1);
      lcd.print("  ");
      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        if (profile.ki1 >= 255)
        {
          profile.ki1 = 255;
        }
        else profile.ki1 = profile.ki1 + 1;
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        if (profile.ki1 < 1)
        {
          profile.ki1 = 0;
        }
        else profile.ki1 = profile.ki1 - 1;
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        reflowState = REFLOW_STATE_MENU_TOP_D;
        SaveProfile ();
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
    case REFLOW_STATE_MENU_TOP_D:
      lcd.setCursor(8, 3);
      lcd.print("D=");
      lcd.print(profile.kd1);
      lcd.print("  ");
      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        if (profile.kd1 >= 255)
        {
          profile.kd1 = 255;
        }
        else profile.kd1 = profile.kd1 + 1;
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        if (profile.kd1 < 1)
        {
          profile.kd1 = 0;
        }
        else profile.kd1 = profile.kd1 - 1;
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        SaveProfile ();
        lcd.clear();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        lcd.clear();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

    //---------------
    //ПРЕДНАГРЕВ НИ
    case REFLOW_STATE_PRE_HEATER:
      if (tc2 >= 50)                          //Преднагрев до 50°С по датчику НИ
      {
        reflowState = REFLOW_STATE_STEP_RAMP;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_COMPLETE;
      }
      break;
    //---------------

    //"старт и процесс пайки", рост температуры с заданной скоростью
    case REFLOW_STATE_STEP_RAMP:
      digitalWrite(Int_Fan, HIGH); //включить охладитель симисторов и контроллера
      //if (tc2 >= SP2-2 && !TopStart) TopStart = true;  //если по данным ДАТЧИКА НИЗА температура НИ вышла на уставку, или уставкУ минус 2°С, включаем верхний нагреватель
      //if (tc1 >= 118 && !TopStart) TopStart = true; //если по данным ДАТЧИКА У ЧИПА температура низа больше, или равна 118*С включаем верхний нагреватель
      //if (tc1 >= SP2 - 10 && !TopStart) TopStart = true; //если по данным ДАТЧИКА У ЧИПА низ достиг уставки, или уставки минус 10°С, включаем верхний нагреватель
      if (tc1 >= SP2 - 20 && !TopStart) TopStart = true; //если по данным ДАТЧИКА У ЧИПА низ достиг уставки, или уставки минус 20°С, включаем верхний нагреватель
      if (TopStart == true) //включаем верхний нагреватель
        //-------------------------------------------------------------------------------------------
      { //открываем скобку (чтоб не запутаться)
        if (flag == 0) //фиксируем стартовую температуру
        {
          startTemp = tc1;
          flag = 1;
        }
        //устанавливаем нужный шаг, до которого нагрета плата
        if (startTemp > profile.temperatureStep[currentStep - 1])
        {
          for (x = 1; startTemp > profile.temperatureStep[currentStep - 1]; currentStep++)
          {
            x++;
          }
        }
        if (currentStep > x && flag == 1)
        {
          flag = 0;
          startTemp = profile.temperatureStep[currentStep - 2];
          flag = 1;
        }
        lcd.setCursor(17, 1);
        lcd.print(currentStep);
        lcd.setCursor(8, 3);
        lcd.print(SP2);
        lcd.print("  ");

        //счётчик скорости роста температуры
        if ((currentMillis - previousMillis) > 1000 / (profile.rampRateStep[currentStep - 1] * 0.1)) //скорость роста температуры от 0.1с. до 3с.
        {
          previousMillis = currentMillis;
          counter = counter + 1;
          setpointRamp = counter + startTemp;
          lcd.setCursor(8, 2);
          lcd.print("   ");
          lcd.setCursor(8, 2);
          lcd.print(setpointRamp);
          lcd.print("  ");
          Setpoint1 = setpointRamp;
        }
      } //закрывам скобку
      //----------------------------------------------------------------------------------------

      if (setpointRamp >= profile.temperatureStep[currentStep - 1]) //если достигли нужной температуры
      {
        lcd.setCursor(8, 2);
        lcd.print(profile.temperatureStep[currentStep - 1]);
        reflowState = REFLOW_STATE_STEP;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        digitalWrite(Int_Fan, LOW);             //выключить охладитель симисторов и контроллера
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;
        updateScreen = true;
      }
      break;

    case REFLOW_STATE_STEP:
      Setpoint1 = profile.temperatureStep[currentStep - 1];
      if (Input1 >= profile.temperatureStep[currentStep - 1])
      {
        counter = 0;
        reflowState = REFLOW_STATE_STEP_DWELL;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        digitalWrite(Int_Fan, LOW);              //выключить охладитель симисторов и контроллера
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;
        updateScreen = true;
      }
      break;

    //считаем время перехода на следующий шаг
    case REFLOW_STATE_STEP_DWELL:
      if (currentMillis - previousMillis > 1000)
      {
        previousMillis = currentMillis;
        counter = counter + 1;
      }
      if (counter >= profile.dwellTimerStep[currentStep - 1]) //если счётчик равен установленному времени
      {
        tone(buzzerPin, 1045, 500);  //звуковой сигнал
        counter = 0;
        setpointRamp = 0;
        if (profile.profileSteps == currentStep) //если достигли последнего шага
        {
          currentStep = 1;
          x = 1;      //устанавливаем переменную в исходное состояние
          flag = 0;   //после завершения профиля сбрасываем флаг
          reflowState = REFLOW_STATE_COMPLETE;
        }
        else { //если шаг не последний
          currentStep++; //переходим на следующий шаг
          reflowState = REFLOW_STATE_STEP_RAMP;
        }
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        digitalWrite(Int_Fan, LOW); //выключить охладитель симисторов и контроллера
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;
        updateScreen = true;
      }
      break;

    //завершение пайки
    case REFLOW_STATE_COMPLETE:
      //digitalWrite(Ext_Fan, HIGH); //включить охладитель платы
      digitalWrite(Int_Fan, LOW); //выключить охладитель симисторов и контроллера
      reflowStatus = REFLOW_STATUS_OFF;
      reflowState = REFLOW_STATE_IDLE;
      updateScreen = true;
      break;
  }

  //включение нагревателей
  if (reflowStatus == REFLOW_STATUS_ON)
  {
    if (updateScreen)
    {
      lcd.setCursor(8, 0);
      lcd.print("RUN!");
      updateScreen = false;
    }
    if (millis() > nextRead1)
    {
      //двигаем звездочки по экрану и готовим данные для вывода на ПК
      nextRead1 = millis() + GRAPHICS_SAMPLING_TIME;

#ifdef SerialPortPlotter
      //sprintf (buf, "$%03d %03d %03d %03d;", int(Output1), int(Output2), tc1, tc2); // стандартный вывод данных
      sprintf (buf, "$%03d %03d %03d %03d %03d %03d %03d;", int(Output1), int(Output2), tc1, tc2, int(p2), int(integra2), int(d2)); // расширенный вывод данных для настройки НИ
#endif

#ifndef SerialPortPlotter
      sprintf (buf, "OK%03d%03d%03d%03d%03d\r\n", int(Output1), int(Output2), tc1, tc2, currentProfile);
#endif

      //StarsRun ();                                    //двигаем звездочки по дисплею во время пайки
    }
    if (millis() > nextRead2)
    {
      nextRead2 = millis() + SENSOR_SAMPLING_TIME; //считываем данные с термопар и считаем ПИД
      Input1 = Input1 * 0.8 + 0.2 * (max6675_read_temp (thermoCLK, thermoCStop, thermoSO)); //термопара "ВЕРХНЕГО" нагревателя
      Input2 = Input2 * 0.8 + 0.2 * (max6675_read_temp (thermoCLK, thermoCSbott, thermoSO)); //термопара "НИЖНЕГО"  нагревателя
      tc1 = Input1;
      tc2 = Input2;

#ifdef LongBottomPid
      //----при использовании Pid2TEST2 для очень инерционного НИ
      if (reflowState != REFLOW_STATE_PRE_HEATER) Output2 = Pid2TEST2(Input2, SP2, profile.kp2, profile.ki2, profile.kd2, kf2);
#endif

#ifndef LongBottomPid
      //----при использовании Pid2 стандартного
      if (reflowState != REFLOW_STATE_PRE_HEATER) Output2 = Pid2(Input2, SP2, profile.kp2, profile.ki2, profile.kd2);
#endif

      if (TopStart) Output1 = Pid1(Input1, Setpoint1, profile.kp1, profile.ki1, profile.kd1); else Output1 = 0;

      lcd.setCursor(16, 2);
      lcd.print("    ");
      lcd.setCursor(16, 2);
      if (isnan(Input1))
      {
        lcd.print("Er");
      } else {
        lcd.print(tc1);
      }
      lcd.setCursor(16, 3);
      lcd.print("    ");
      lcd.setCursor(16, 3);
      if (isnan(Input2))
      {
        lcd.print("Er");
      } else {
        lcd.print(tc2);
      }
    }
  } else {
    digitalWrite(RelayPin1, LOW);
    digitalWrite(RelayPin2, LOW);
  }
}                                             //конец основного цикла программы

void Dimming()
{
  static byte Secs;
#ifdef SerialPortPlotter
  if (Secs >= 100)                            //каждые 100 прерываний отправляем данные через serial
  {
    Serial.println(buf);
    Secs = 1;                                 //Начинаем считать с 1, т.к. в первый шаг мы только присваиваем значение, но не прибавляем.
  } else Secs++;
#endif
  if (reflowStatus == REFLOW_STATUS_ON)
  {
    OutPWR_TOP();
    OutPWR_BOTTOM();
  }
}

void OutPWR_TOP()
{
  reg1 = Output1 + er1;                       //pwr- задание выходной мощности в %, er- ошибка округления
  if (reg1 < 50)
  {
    out1 = LOW;
    er1 = reg1 ;                              //reg- переменная для расчетов
  } else {
    out1 = HIGH;
    er1 = reg1 - 100;
  }
  digitalWrite(RelayPin1, out1);              //пин через который осуществляется дискретное управление
}

void OutPWR_BOTTOM()
{
  reg2 = Output2 + er2;                       //pwr- задание выходной мощности в %, er- ошибка округления
  if (reg2 < 50) {
    out2 = LOW;
    er2 = reg2 ;                              //reg- переменная для расчетов
  } else {
    out2 = HIGH;
    er2 = reg2 - 100;
  }
  digitalWrite(RelayPin2, out2);              //пин через который осуществляется дискретное управление
}

byte Pid1(double temp, byte ust, byte kP, byte kI, byte kd)
{
  byte out = 0;
  static float ed = 0;
  e1 = (ust - temp);                          //ошибка регулирования
  p1 =  (kP * e1);                            //П составляющая
  integra = (integra < i_min) ? i_min : (integra > i_max) ? i_max : integra + (kI * e1) / 1000; //И составляющая
  d1 = kd * (temp - ed); //Д составляющая
  ed = temp;
  out = (p1 + integra - d1 < profile.min_pwr_TOPStep[currentStep - 1]) ? profile.min_pwr_TOPStep[currentStep - 1] : (p1 + integra - d1 > profile.max_pwr_TOPStep[currentStep - 1]) ? profile.max_pwr_TOPStep[currentStep - 1] : p1 + integra - d1;
  return out;
}

#ifdef LongBottomPid
//----ПИД для очень инерционного НИ
byte Pid2TEST2(double temp, int ust, byte kP, byte kI, byte kD, byte kF)
{
  byte out = 0;
  static const byte buff_depth = 8; // глубина буфера 4 = 1 секунда, 8 = 2 секунды... MAX 250, увеличение кушает память.
  static float ed[buff_depth]; // массив предыдущих измерений ошибки (виден только внутри функции пид)
  static float ef[buff_depth]; // массив предыдущих измерений температуры (виден только внутри функции пид)
  static byte buff_position;
  e2 = e2 * 0.75 + 0.25 * (ust - temp); //ошибка регулирования Сглаживание на 4 шага
  p2 = (kP * e2 / 10); //П составляющая
  integra2 = (integra2 < i_min) ? i_min : (integra2 > i_max) ? i_max : integra2 + (kI * e2) / 10000.0; //И составляющая
  d2 = kD * (e2 - ed[buff_position]); //Д составляющая // сравниваем со значением ошибки 8 шагов назад, если ошибка уменьшилась уменьшаем ПИД
  f2 = kF * (temp - ef[buff_position]); // скорость изменения температуры, если быстро растет, гасим пид, если быстро падает - подпинываем
  ed[buff_position] = e2; // Запись ошибки buff_depth шагов назад
  ef[buff_position] = temp; // Запись температуры buff_depth шагов назад
  buff_position = (buff_position < buff_depth - 1) ? buff_position + 1 : 0; //если достигли последнего значения буфера начинаем писать с 0
  out = (p2 + integra2 + d2 - f2 > 100 ) ? 100 : (p2 + integra2 + d2 - f2  < 0 ) ? 0 : p2 + integra2 + d2 - f2;  // Ограничиваем выходные значения 0-100
  return out;
}
#endif

#ifndef LongBottomPid
//----ПИД для "шустрых" НИ на галогенках и им подобных излучателях
byte Pid2(double temp, int ust, byte kP, byte kI, byte kd)
{
  byte out = 0;
  static float ed = 0;
  e2 = (ust - temp); //ошибка регулирования
  p2 =  (kP * e2); //П составляющая
  integra2 = (integra2 < i_min) ? i_min : (integra2 > i_max) ? i_max : integra2 + (kI * e2) / 1000; //И составляющая
  d2 = kd * (temp - ed) ; //Д составляющая
  ed = temp;
  out = (p2 + integra2 - d2 < 0) ? 0 : (p2 + integra2 - d2 > profile.pwr_BOTTOM) ? profile.pwr_BOTTOM : p2 + integra2 - d2;
  return out;
}
#endif

//---MAX6675 functions---//
double max6675_read_temp (int ck, int cs, int so)
{ char i;
  int tmp = 0;
  digitalWrite(cs, LOW);//cs = 0;                            // Stop a conversion in progress
  asm volatile (" nop"  "\n\t");
  for (i = 15; i >= 0; i--)
  { digitalWrite(ck, HIGH);
    asm volatile (" nop"  "\n\t");
    if ( digitalRead(so))
      tmp |= (1 << i);
    digitalWrite(ck, LOW);
    asm volatile (" nop"  "\n\t");
  }
  digitalWrite(cs, HIGH);
  if (tmp & 0x4) {
    return NAN;
  } else
    return ((tmp >> 3)) * 0.25;
}
//---MAX6675 functions---//

//---работа с профилями в EEPROM---//
void loadProfile()                                  //чтение профиля из EEPROM
{
  //for (byte j = 0; j <= SizeProfile - 1; j++) EEPROM.get((currentProfile - 1)*SizeProfile, profile);
  EEPROM.get((currentProfile - 1)*SizeProfile, profile);
}
void SaveProfile ()                                 //сохранение текущего профиля
{
  //for (byte j = 0; j <= SizeProfile - 1; j++) EEPROM.put((currentProfile - 1)*SizeProfile, profile);
  EEPROM.put((currentProfile - 1)*SizeProfile, profile);
}
//---работа с профилями в EEPROM---//

//---Мелодия приветствия---//
void SongHello () {
  tone(buzzerPin, 523);
  delay(200);
  tone(buzzerPin, 659);
  delay(200);
  tone(buzzerPin, 784);
  delay(200);
  tone(buzzerPin, 1046);
  delay(200);
  noTone(buzzerPin);
}
//---Мелодия приветствия---//

//---звук при нажатии на кнопки---//
void ClickBeep () {
  if (upSwitchState == HIGH || downSwitchState == HIGH || cancelSwitchState == HIGH || okSwitchState == HIGH || rightSwitchState == HIGH)
  {
    tone(buzzerPin, 1045);
    delay(100);
    noTone(buzzerPin);
  }
}
//---звук при нажатии на кнопки---//

//---звук предупреждения---//
void GongAlarm () {
  tone(buzzerPin, 1046);
  delay(100);
  noTone(buzzerPin);
  delay(100);
  tone(buzzerPin, 1046);
  delay(100);
  noTone(buzzerPin);
  delay(100);
  tone(buzzerPin, 1046);
  delay(100);
  noTone(buzzerPin);
  delay(100);
  tone(buzzerPin, 1046);
  delay(100);
  noTone(buzzerPin);
  delay(100);
}
//---звук предупреждения---//

//---двигаем звездочки по дисплею во время пайки---//
void StarsRun () {
  if (curCount <= 6)
  {
    lcd.setCursor(curCount, 0);
    lcd.print(" *");
    lcd.setCursor(18 - curCount, 0);
    lcd.print("* ");
  }
  if (curCount > 6)
  {
    lcd.setCursor(13 - curCount, 0);
    lcd.print("* ");
    lcd.setCursor(curCount + 5, 0);
    lcd.print(" *");
  }
  curCount++;
  if (curCount > 13) curCount = 0;
}
//---двигаем звездочки по дисплею во время пайки---//

/*
  //Классическая версия ПИД для ВИ и для НИ, расчет по конечной величине ошибки.
  //При работе этой версии с использованием рампы, при изменении значения рампы,
  //т.е приращения температуры, происходит мгновенный выброс мощности на нагреватели.
  //Это явление выглядит как моргание ламп с периодичностью пропорциональной скорости
  //роста температуры. Для керамики не существенно, но для ламп нехорошо.
  byte Pid1(double temp, byte ust, byte kP, byte kI, byte kd)
  {
  byte out = 0;
  static float ed = 0;
  e1 = (ust - temp); //ошибка регулирования
  p1 =  (kP * e1); //П составляющая
  integra = (integra < i_min) ? i_min : (integra > i_max) ? i_max : integra + (kI * e1) / 1000; //И составляющая
  d1 = kd * (e1 - ed) * 10; //Д составляющая
  ed = e1;
  out = (p1 + integra + d1 < 0) ? 0 : (p1 + integra + d1 > pwr_TOP) ? pwr_TOP : p1 + integra + d1;
  return out;
  }

  byte Pid2(double temp, byte ust, byte kP, byte kI, byte kd)
  {
  byte out = 0;
  static float ed = 0;
  e2 = (ust - temp); //ошибка регулирования
  p2 =  (kP * e2); //П составляющая
  integra2 = (integra2 < i_min) ? i_min : (integra2 > i_max) ? i_max : integra2 + (kI * e2) / 1000; //И составляющая
  d2 = kd * (e2 - ed) * 10; //Д составляющая
  //ed = e1;
  ed = e2;
  out = (p2 + integra2 + d2 < 0) ? 0 : (p2 + integra2 + d2 > profile.pwr_BOTTOM) ? profile.pwr_BOTTOM : p2 + integra2 + d2;
  return out;
  }
*/

//другие мелодии приветствия
/*
  //Гимн СССР https://clck.ru/FX6CG
    tone(buzzerPin, 174, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 233, 499.9995);
    delay(555.555);
    tone(buzzerPin, 174, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 195, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 220, 499.9995);
    delay(555.555);
    tone(buzzerPin, 146, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 146, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 195, 499.9995);
    delay(555.555);
    tone(buzzerPin, 174, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 155, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 174, 499.9995);
    delay(555.555);
    tone(buzzerPin, 116, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 116, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 130, 499.9995);
    delay(555.555);
    tone(buzzerPin, 130, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 146, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 155, 499.9995);
    delay(555.555);
    tone(buzzerPin, 155, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 174, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 195, 499.9995);
    delay(555.555);
    tone(buzzerPin, 220, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 233, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 261, 749.99925);
    delay(833.3325);
    tone(buzzerPin, 174, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 293, 499.9995);
    delay(555.555);
    tone(buzzerPin, 261, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 233, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 261, 499.9995);
    delay(555.555);
    tone(buzzerPin, 174, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 174, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 233, 499.9995);
    delay(555.555);
    tone(buzzerPin, 220, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 195, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 220, 499.9995);
    delay(555.555);
    tone(buzzerPin, 146, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 146, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 195, 499.9995);
    delay(555.555);
    tone(buzzerPin, 174, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 155, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 174, 499.9995);
    delay(555.555);
    tone(buzzerPin, 116, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 116, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 233, 499.9995);
    delay(555.555);
    tone(buzzerPin, 220, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 195, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 174, 999.999);
    delay(1111.11);
    tone(buzzerPin, 293, 999.999);
    delay(1111.11);
    tone(buzzerPin, 261, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 233, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 220, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 233, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 261, 749.99925);
    delay(833.3325);
    tone(buzzerPin, 174, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 174, 999.999);
    delay(1111.11);
    tone(buzzerPin, 233, 999.999);
    delay(1111.11);
    tone(buzzerPin, 220, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 195, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 174, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 195, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 220, 749.99925);
    delay(833.3325);
    tone(buzzerPin, 146, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 146, 999.999);
    delay(1111.11);
    tone(buzzerPin, 233, 499.9995);
    delay(555.555);
    tone(buzzerPin, 195, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 220, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 233, 499.9995);
    delay(555.555);
    tone(buzzerPin, 195, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 220, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 233, 499.9995);
    delay(555.555);
    tone(buzzerPin, 195, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 233, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 311, 999.999);
    delay(1111.11);
    tone(buzzerPin, 311, 999.999);
    delay(1111.11);
    tone(buzzerPin, 293, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 261, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 233, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 261, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 293, 749.99925);
    delay(833.3325);
    tone(buzzerPin, 233, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 233, 999.999);
    delay(1111.11);
    tone(buzzerPin, 261, 999.999);
    delay(1111.11);
    tone(buzzerPin, 233, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 220, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 195, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 220, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 233, 749.99925);
    delay(833.3325);
    tone(buzzerPin, 195, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 195, 999.999);
    delay(1111.11);
    tone(buzzerPin, 233, 499.9995);
    delay(555.555);
    tone(buzzerPin, 220, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 195, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 174, 499.9995);
    delay(555.555);
    tone(buzzerPin, 116, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 116, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 174, 999.999);
    delay(1111.11);
    tone(buzzerPin, 195, 499.9995);
    delay(555.555);
    tone(buzzerPin, 220, 499.9995);
    delay(555.555);
    tone(buzzerPin, 233, 1999.998);
    delay(2222.22);
*/
/*
  //Мелодия приветствия Марио
  tone(buzzerPin,1318,150);
  delay(150);
  tone(buzzerPin,1318,300);
  delay(300);
  tone(buzzerPin,1318,150);
  delay(300);
  tone(buzzerPin,1046,150);
  delay(150);
  tone(buzzerPin,1318,300);
  delay(300);
  tone(buzzerPin,1568,600);
  delay(600);
  tone(buzzerPin,784,600);
  delay(600);
  noTone(buzzerPin);
*/
